var CollapsedElements = [];
var ExpandedElements = [];
var doingPDF = false;
var dontPerformForEachHost = false;

var StatusgridEvents = {
    itemsStore: new Ext.util.LocalStorage({id: "items"}),
    setTitle: function() {
        var title = Ext.get('gridTitle');
        if (!title || !parent.setPageTitle)
            return;

        parent.setPageTitle(title.dom.value,0);
    },
    displayRows: function(img, save, system) {
        var saveOnCookie = (typeof save === "boolean") ? save : true;
        var isNotFromSystem = (typeof system === "boolean") ? system : true;
        var isToCollapse = !!(img.src.match("minus"))

        var id = img.getAttribute("data-id");
        var getParent = StatusgridHelpers.getParent("grid-row-border");
        var getSiblings = StatusgridHelpers.takeNextSiblingWhile(function(el) {
            return !!el.className.match(id);
        });

        var arr = getSiblings(getParent(img).nextElementSibling);
        var argsImgsToReplace = isToCollapse ? [ "minus", "plus" ] : [ "plus", "minus"];

        // perform collapsing/expanding
        Ext.each(arr, function(obj) {
            var row = Ext.get(obj);
            row.setVisibilityMode(Ext.Element.DISPLAY);
            row.toggle();
            img.src = img.src.replace.apply(img.src, argsImgsToReplace);
        });

        if (isNotFromSystem) {
            // perform change
            var params =
                (isToCollapse)
                    ? [ img, CollapsedElements, ExpandedElements ]
                    : [ img, ExpandedElements, CollapsedElements ];

            // update memory state
            StatusgridEvents.triggerStateChange.apply (StatusgridEvents, params);
        }

        if (saveOnCookie) {
            // update cookie state
            StatusgridEvents.saveDisplayRows(CollapsedElements, ExpandedElements);
        }
    },
    triggerStateChange: function(img, toPush, toSplice) {
        var id = img.getAttribute('data-id');
        var startRemoveFrom = toSplice.indexOf(id);

        if (toPush.indexOf(id) < 0) {
            toPush.push(id);
        }

        if (startRemoveFrom >= 0) {
            toSplice.splice(startRemoveFrom, 1);
        }
    },
    saveDisplayRows: function (collapseddata, expandeddata) {
        //save cookie with collapsed grid
        setCookie('collapsedElements', JSON.stringify(collapseddata), '365', '/', '', '' );
        setCookie('extendedElements', JSON.stringify(expandeddata || []), '365', '/', '', '' );
    },
    restoreDisplayRows: function(fromCookie) {
        var isFromCookie = (typeof fromCookie === "boolean") ? fromCookie : true;
        //restore collapsed grid data
        var collapseddata = JSON.parse(getCookie('collapsedElements'));
        var expandeddata = JSON.parse(getCookie('extendedElements'));
        CollapsedElements = (collapseddata || []).concat (CollapsedElements);
        ExpandedElements = (expandeddata || []).concat (ExpandedElements);

        Ext.each(CollapsedElements, function(id) {
            var img = Ext.query("img[data-id=" + id + "]");
            img = Ext.get(img[0]);

            if (img) {
                StatusgridEvents.displayRows(img.dom, isFromCookie);
            }
        });
    },
    getGridCheckboxes: function() {
        return Ext.query('input.row-checkbox');
    },
    checkAndUncheck: function(main) {
        if (main.checked)
            StatusgridEvents.cookieAddEl(main.getAttribute('data-id'));
        else
            StatusgridEvents.cookieDelEl(main.getAttribute('data-id'));

        var boxes = [];
        boxes = this.getGridCheckboxes();
        Ext.each(boxes, function(cbox) {
            var valid_ids = /^\d+.*$/;

            if (!String(cbox.getAttribute('data-id')).match(valid_ids))
                return;

            cbox.checked = main.checked;
            StatusgridEvents.selectRow({ target: cbox });
        });
    },
    toggleCheckServiceGrid: function(xs) {
        var me = this;

        return function(main) {
            var init = "indeterminate";

            var states = [ init, "checked", "unchecked" ];

            var selector = StatusgridComboSelector(init);

            var nextState = selector.getNextState(main, states);

            var inputs = xs || me.getGridCheckboxes();

            dontPerformForEachHost = true;

            selector.performChanges(nextState, main, inputs);
        }
    },
    getChildrenCheckboxes: function(name) {
        var checkboxes = [];
        checkboxes = Ext.query(".child-"+name);
        checkboxes = checkboxes.concat(Ext.query("input[data-id^="+name+"!]"));
        return checkboxes;
    },
    verifyCheckbox: function(event, cbox) {

        /**
         * user has selected a host,
         * a service group or a host group,
         * check/uncheck all children
         */
        if (cbox.getAttribute('data-id').indexOf("!") < 0 && !dontPerformForEachHost) {
            var nextElement = StatusgridHelpers.getParent("grid-row")(cbox).nextElementSibling;
            if (nextElement) {
                var query = nextElement.querySelector('input[type="checkbox"]');
                var flag = query && (query.getAttribute("data-id") || "").indexOf("!") >= 0;
                if (flag) {
                    var xs = StatusgridEvents.getChildrenCheckboxes(cbox.getAttribute('data-id'));
                    StatusgridEvents.toggleCheckServiceGrid(xs) (cbox);
                }
            }
        }

        if (cbox.checked)
            StatusgridEvents.cookieAddEl(cbox.getAttribute('data-id'));
        else
            StatusgridEvents.cookieDelEl(cbox.getAttribute('data-id'));
    },
    addService: function() {
        var props = {};
        props.action = "addService";
        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    delService: function() {
        var props = {};
        var i;
        var arr;
        var obj;
        var sel;

        sel = StatusgridEvents.getSelectedCheckboxes();
        if (sel.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        props.services = [];
        for(i=0; i<sel.length; i++) {
            arr = sel[i].match(/(\d+)!(\d+)/);
            if (arr === null || arr.length != 3) {
                continue;
            }

            obj = {
                host_id: arr[1],
                service_id: arr[2]
            };
            props.services.push(obj);
        }

        if (props.services.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        props.action = "deleteServices";
        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);

    },
    cookieAddEl: function(idx) {
        var elems = StatusgridEvents.getIdsFromStorage();
        if (StatusgridEvents.findElemIndex(idx,elems) > -1) return;
        elems.push(idx);
        StatusgridEvents.itemsStore.setItem("items", elems);
    },
    cookieDelEl: function(idx) {
        var elems = StatusgridEvents.getIdsFromStorage();
        var index = StatusgridEvents.findElemIndex(idx,elems);
        if (index > -1) {
            elems.splice(index,1);
            StatusgridEvents.itemsStore.setItem("items", elems);
        }
    },
    getIdsFromStorage: function() {
        var keysFromStorage = StatusgridEvents.itemsStore.getItem("items");
        return (keysFromStorage && keysFromStorage !== "")
            ? keysFromStorage.split(",")
            : [];
    },
    findElemIndex: function(elem,arr) {
        if ((arr === null) || (arr === undefined))
            return -1;

        for (var i=0; i<arr.length;i++) {
            if (elem == arr[i]) {
                return i;
            }
        }
        return -1;
    },
    addCheckboxListeners: function() {
        var elems = StatusgridEvents.getIdsFromStorage();

        // Add new listeners
        Ext.each(this.getGridCheckboxes(), function(element) {
            var checkbox = Ext.get(element);
            checkbox.on('change', function(event) {
              StatusgridEvents.verifyCheckbox.apply(this, arguments);
              StatusgridEvents.selectRow(event);
            });
        });

        if (elems.length) {
            for (var i=0; i<elems.length; i++) {
                var checkbox = Ext.query('input[data-id=' + elems[i] + ']');
                if (checkbox.length !== 1)
                    continue;

                checkbox = Ext.get(checkbox[0]);
                checkbox.dom.click();
                StatusgridEvents.verifyCheckbox(false,checkbox.dom);
            }
        }
    },
    findCheckboxIndex: function(id) {
        var sel;
        sel = StatusgridEvents.getSelectedCheckboxes();
        for (var i=0; i<sel.length;i++) {
            if (id == sel[i])
                return i;
        }
        return -1;
    },
    noElementSelected: function() {

        var win = Ext.getCmp('alertWin');
        if (!win) {
            win = new Ext.Window({
                applyTo: 'alertWin',
                id: 'alertWin',
                contentEl: 'noElementsWin',
                layout: 'fit',
                width: 300,
                autoHeight:    true,
                buttonAlign: 'center',
                plain: false,
                modal: true,
                closable: false,
                closeAction: 'hide',
                draggable: false,
                shadow: false,
                baseCls: 'ext-window',
                bodyBorder: false,
                hideBorders: true,
                border: true,
                resizable: false
            });
        }
        win.center();
        win.show();
    },
    cannotRemoveOpmon: function() {

        var win = Ext.getCmp('alertOpmonWin');
        if (!win) {
            win = new Ext.Window({
                applyTo: 'alertOpmonWin',
                id: 'alertOpmonWin',
                contentEl: 'cannotRemoveOpmonWin',
                layout: 'fit',
                width: 300,
                autoHeight:    true,
                buttonAlign: 'center',
                plain: false,
                modal: true,
                closable: false,
                closeAction: 'hide',
                draggable: false,
                shadow: false,
                baseCls: 'ext-window',
                bodyBorder: false,
                hideBorders: true,
                border: true,
                resizable: false
            });
        }
        win.center();
        win.show();
    },
    validateBasicSearch: function(form) {
        var obj = form.elements[0];
        var btn = parent.Ext.get("cancelSearch");

        if (obj.value.length) {
            obj.className += " filter-active";

            btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
            btn.dom.style.cursor = "pointer";
        } else {
            if (obj.className.match(" filter-active"))
                obj.className = "basic-search-input";

            btn.dom.style.cursor = "default";
        }

        StatusgridEvents.hideAdvancedSearch();
    },
    cancelSearch: function() {
        var form = parent.Ext.get('searchForm').dom;
        form.reset();
        StatusgridEvents.hideAdvancedSearch();
        parent.mFrame.StatusgridEvents.validateBasicSearch(form);
        form.submit();
    },
    showAdvancedSearch: function() {
        var statusgridBlock = document.getElementById("statusgridBlock");
        if (!statusgridBlock) {
            return StatusgridEvents.oldAdvancedFilter();
        }
        var frame = document.getElementById("advancedFilterIframe");
        var formUrl = statusgridBlock.getAttribute("data-form-url");
        if (frame.src) {
            return frame.filterActions.openWindow();
        }
        Ext.getBody().mask("Preparing advanced filter");
        frame.src = "/opmon/seagull/modules/workspace/templates/statusgridAdvancedFilter/index.html";
        frame.statusgrid = statusgridBlock.getAttribute("data-statusgrid");
        frame.appLoadTrigger = function() {
            frame.filterActions.openWindow();
            Ext.getBody().unmask();
        };
        frame.applyHandler = StatusgridEvents.applyHandlerForAdvancedSearch.bind(StatusgridEvents, formUrl)
        try {
            var data = StatusgridEvents.getInitialValuesForAdvancedFilter();
            frame.initialValues = StatusgridEvents.mapAdvancedValues(data);
        } catch(e) {
            frame.initialValues = {};
        }
    },
    oldAdvancedFilter: function() {
        var obj = false;
        var link = false;
        var kbElement = document.querySelector("#colors-kb");

        if (parent) {
            obj = parent.mFrame.Ext.get('gridAdvancedSearch');
            var arr = parent.Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
            delete(arr);
        } else {
            obj = mFrame.Ext.get('gridAdvancedSearch');
            var arr = Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
            delete(arr);
        }

        if (obj.dom.style.display === 'block') {
            link.dom.innerHTML = langArray["Advanced options"];
            obj.dom.style.display = 'none';
        } else {
            link.dom.innerHTML = langArray["Hide options"];
            obj.dom.style.display = 'block';
        }
        if (obj) {
            obj.center();
        }
        if(kbElement && fromNull(kbElement.getAttribute("href"))) {
            var lang = parent.mFrame.Ext.locale.lang;
            var kbLinks = {
                "pt_BR": "http://kb.opservices.com.br/knowledge-base/colors-opmon/",
                "en_US": "http://kb.opservices.com/knowledge-base/colors-opmon/"
            };
            kbElement.setAttribute("href", kbLinks[lang])
        }
        function fromNull(x) {
            return (x === null) || (x === undefined) || (x === "");
        }
    },
    getInitialValuesForAdvancedFilter: function() {
        var removeChars = function(str) {
            return str.toString().match(/^=|~/)
                ? str.toString().replace(/^=|~/, "")
                : str
        };
        var assign = function(key, val, data) {
            var fresh = {};
            fresh[key] = val;
            return Ext.apply({}, fresh, data);
        };
        var dataSource = JSON.parse(advFilter);
        return Object.keys(dataSource).reduce(function(data, key) {
            return Array.isArray(dataSource[key])
                ? assign(key, dataSource[key].map(removeChars), data)
                : assign(key, removeChars(dataSource[key]), data);
        }, {});
    },
    mountAdvancedQueryParam: function(key, value, isArray) {
        return "filter["
            .concat(key)
            .concat("]")
            .concat(isArray ? "[]" : "")
            .concat("=")
            .concat(value)
            .concat("&")
    },
    mountAdvancedValue: function(panel, key, value, isArray) {
        if (!isArray) {
            return value === "-1" ? "" : value;
        }
        if (key === "priorityOrder") {
            return value[0];
        }
        if (key === "display_status") {
            return value;
        }
        return value.map(function(x) {
            var store = panel.query("combobox[name='"+ key +"']").reduce(function(_, el) {
                return el.store;
            }, null);
            var operator = "=";
            if (store) {
                store.clearFilter();
                operator = store.find("display_name", x, 0, false, false, true) === -1 ? "~" : "=";
                if (x[0] === "=" || x[0] === "~") {
                    operator = "";
                }
            }
            return operator.concat(x);
        });
    },
    advancedSearchMapper: {
        state: function(values) {
            var fresh = {};
            fresh.display_status = values.state;
            return fresh;
        },
        display_status: function(values) {
            var fresh = {};
            fresh.state = values.display_status;
            return fresh;
        },
        details: function(values) {
            var fresh = {};
            fresh.plugin_output = values.details || "";
            return fresh;
        },
        plugin_output: function(values) {
            var fresh = {};
            fresh.details = values.plugin_output || "";
            return fresh;
        },
        priorityOrder: function(values) {
            var fresh = {};
            fresh.priorityOrder = Array.isArray(values.priorityOrder)
                ? true
                : [1];
            return fresh;
        },
    },
    mapAdvancedValues: function(values, dir) {
        return Object.keys(values).reduce(function(acc, key) {
            var fresh = {};
            return StatusgridEvents.advancedSearchMapper.hasOwnProperty(key)
                ? Ext.apply({}, acc, StatusgridEvents.advancedSearchMapper[key](values))
                : Ext.apply({}, acc, (fresh[key] = values[key], fresh));
        }, {});
    },
    applyHandlerForAdvancedSearch: function(formUrl, panel, originalValues) {
        var values = StatusgridEvents.mapAdvancedValues(originalValues);

        var params = Object.keys(values).reduce(function(uri, key) {
            var isArr = Array.isArray(values[key]);
            var val = StatusgridEvents.mountAdvancedValue(panel, key, values[key], isArr);
            return uri.concat(
                (isArr && Array.isArray(val))
                    ? val.reduce(function(arr, x) {
                        return arr.concat(StatusgridEvents.mountAdvancedQueryParam(key, x, isArr))
                    }, "")
                    : StatusgridEvents.mountAdvancedQueryParam(key, val, isArr)
            );
        }, "?").concat(
            (Object.keys(values).length > 0) ? "searchPanel=1" : ""
        ).replace(/&$/, "")

        var url = formUrl.concat(params);

        window.location = url;
    },
    renderComboboxes: function() {
        var form = Ext.get('gridAdvancedSearch');

        if (form && form.dom.style.display !== 'none') {
            return;
        }

        // Clean previous allocated memory
        Ext.each(FilterMemoryMgr, function(memObj,memIndex) {
            if (memObj.destroy) {
                //memObj.destroy();
                delete(memObj);
            } else if (memObj.removeAllListeners) {
                memObj.removeAllListeners();
            }
        });

        FilterMemoryMgr = [];

        var objs = Ext.query('.combo-autocomplete');

        Ext.each( objs, function(x,index) {
            var obj = Ext.get(x);
            var ds = new Ext.data.Store({
                proxy: {
                    url: '/opmon/seagull/www/index.php/statusgrid/action/comboContent/filter/' + obj.id,
                    type: 'ajax',
                    autoload: true,
                    noCache: false,
                    actionMethods: {
                        read: 'POST'
                    },
                    reader: {
                        root: 'data',
                        totalProperty: 'total',
                        id: 'id'
                    }
                },
                fields: [
                    {name: 'id', mapping: 'id'},
                    {name: 'display_name', mapping: 'display_name'}
                ]
            });

            FilterMemoryMgr.push(ds);

            var content = obj.dom.innerHTML;
            obj.dom.innerHTML = "";

            var isMultiple = x.getAttribute("data-multi") === "1";

            var combo = Ext.create('Ext.container.Container', {
                width: 198,
                renderTo: x,
                items: [
                    {
                        xtype: "boxselect",
                        store: ds,
                        displayField: 'display_name',
                        loadingText: '',
                        width: 198,
                        minHeight: isMultiple ? 50 : 20,
                        shadow: 'sides',
                        defaultListConfig : {
                            loadingHeight: 70,
                            border: 1,
                            style: {
                                borderStyle: 'solid'
                            },
                            shadow: 'sides',
                            cls: 'copy-shadow'
                        },
                        tpl: new Ext.XTemplate('<ul class="x-list-plain">\n\
                            <tpl for=".">\n\
                                    <li role="option" unselectable="on" class="x-boundlist-item combobox-list">{display_name}</li>\n\
                                </tpl>\n\
                            </ul>'
                        ),
                        labelTpl: Ext.create("Ext.XTemplate",
                            '{[this.removeOp(values.display_name)]}',
                            {
                                removeOp: function(name) {
                                    var head = name[0];
                                    return (head === "=" || head === "~")
                                        ? name.slice(1)
                                        : name;
                                }
                            }
                        ),
                        hideTrigger: true,
                        minChars: 1,
                        //hiddenName: 'filter[' + obj.id + ']' + (isMultiple ? '[]' : ''),
                        cls: 'advanced-form-element combobox-list no-input-border',
                        id: 'combo_' + obj.id,
                        multiSelect: isMultiple,
                        forceSelection: false,
                        createNewOnEnter: true,
                        createNewOnBlur: true,
                        listeners: {
                            change: function(el, values) {
                                var multi = el.up().renderTo.nextElementSibling;
                                if (! multi) return;
                                multi.innerHTML = "";
                                values.split(", ").forEach(function(x) {
                                    if (x === "") { return; }
                                    var opt = document.createElement("option");
                                    var operator = el.store.find("display_name", x) === -1 ? "~" : "=";
                                    if (x[0] === "=" || x[0] === "~") {
                                        operator = "";
                                    }
                                    opt.value = (isMultiple) ? operator + x : x;
                                    opt.selected = true;
                                    opt.text = x;
                                    multi.appendChild(opt);
                                });
                            },
                            afterrender: function(el) {
                                if (content) el.setValue(content.split(", "));
                            }
                        }
                    }
                ]
            });
            FilterMemoryMgr.push(combo);
        });

    },
    hideAdvancedSearch: function() {

        var obj = false;
        var link = false;

        if (parent) {
            obj = parent.mFrame.Ext.get('gridAdvancedSearch');
            var arr = parent.Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
        } else {
            obj = mFrame.Ext.get('gridAdvancedSearch');
            var arr = Ext.query('.basic-search-advanced');
            link = Ext.get(arr[0]);
        }

        link.dom.innerHTML = langArray["Advanced options"];
        obj.dom.style.display = 'none';

    },
    validateAdvancedSearch: function(form) {
        var search = false;
        var btn = false;

        if (parent) {
            var arr = parent.Ext.query('.basic-search-input');
            search = arr[0];
            delete(arr);

            btn = parent.Ext.get("cancelSearch");
        } else {
            var arr = Ext.query('.basic-search-input');
            search = arr[0];
            delete(arr);

            btn = Ext.get("cancelSearch");
        }

        search.value = "(" + langArray["Filter activated"] + ")";
        if (!search.className.match(" filter-active")) {
            search.className += " filter-active";
        }

        btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");

        btn.dom.style.cursor = "pointer";

        StatusgridEvents.hideAdvancedSearch();
    },
    renderDatetimePicker: function() {

        Date.monthNames = [
            langArray["Jan"],
            langArray["Feb"],
            langArray["Mar"],
            langArray["Apr"],
            langArray["May"],
            langArray["Jun"],
            langArray["Jul"],
            langArray["Aug"],
            langArray["Sep"],
            langArray["Oct"],
            langArray["Nov"],
            langArray["Dec"]
        ];

        Date.dayNames = [
            langArray["Sunday"],
            langArray["Monday"],
            langArray["Tuesday"],
            langArray["Wednesday"],
            langArray["Thursday"],
            langArray["Friday"],
            langArray["Saturday"]
        ];

        if(Ext.DatePicker){
            Ext.apply(Ext.DatePicker.prototype, {
              todayText         : langArray["Today"],
              monthNames        : Date.monthNames,
              dayNames          : Date.dayNames,
              cancelText    : langArray["Cancel"]
            });
        }

        var form = Ext.get('gridAdvancedSearch');
        if (form) {
            if (form.dom.style.display != 'none')
            return;
        }

        var objs = Ext.query('.datetime-picker');

        var downtime_adv_search = Ext.get("adv-search-window-downtimes");

        Ext.each( objs, function(x,index) {
            var obj = Ext.get(x);

            var content = obj.dom.innerHTML;
            obj.dom.innerHTML = "";

            var has_cache = (content.split(" ").length == 2);
            var tmp = new Date();

            if (has_cache) {
                tmp = content.split(" ")[0];
                if (tmp.match(/\d\d-\d\d-\d\d/)) {
                    tmp = '20' + content.split(" ")[0];
                }
            }

            if ((obj.id == 'log_day_end') || (obj.id == 'log_day')) {
                var date = (has_cache) ? content.split(" ")[0] : new Date();
                var time = (has_cache) ? content.split(" ")[1] : '00:00:00';

                if ((has_cache) && (date.match(/^\d\d-\d\d-\d\d/))) {
                    date = '20' + date;
                }
            }

            var field = new Ext.form.FormPanel({
                renderTo:       x
                ,width:         210
                ,layout:        {
                     type:        'hbox'
                    ,pack:        'start'
                    ,align:        'top'
                }
                ,id:                obj.id + '_panel'
                ,bodyPadding:        0
                // ,disabled:          ((downtime_adv_search !== null) && (!downtime_bydate))
                ,disabled:          (downtime_adv_search !== null)
                ,items: [{
                    xtype:          'datefield'
                    ,margin:        '0 2 0 2'
                    ,minWidth:        110
                    ,height:        22
                    ,allowBlank:    false
                    ,editable:      false
                    ,name:          'filter[date_'+obj.id+']'
                    ,cls:           'no-input-border'
                    ,format:        'Y-m-d'
                    ,id:            obj.id + '_date'
                    ,value:         date
                    ,flex:            1
                }, {
                    xtype:          'timefield'
                    ,minWidth:         100
                    ,height:        22
                    ,allowBlank:    false
                    ,editable:      true
                    ,name:          'filter[time_'+obj.id+']'
                    ,id:            obj.id + '_time'
                    ,cls:           'no-input-border'
                    ,value:            time
                    ,minValue:      '00:00:00'
                    ,maxValue:      '23:59:59'
                    ,increment:     15
                    ,format:        'H:i:s'
                    ,flex:            1
                }]
            });

            if ((!has_cache) && (obj.id == 'log_day_end')) {
                field.down('#'+obj.id+'_time').setValue('23:59:59');
            }

            FilterMemoryMgr.push(field);
        });

        if (downtime_adv_search !== null) {
            StatusgridEvents.downtimeAdvSearchBehavior(Ext.get("by_date").dom);
        }

    },
    renderDatePicker: function() {

        Date.monthNames = [
            langArray["Jan"],
            langArray["Feb"],
            langArray["Mar"],
            langArray["Apr"],
            langArray["May"],
            langArray["Jun"],
            langArray["Jul"],
            langArray["Aug"],
            langArray["Sep"],
            langArray["Oct"],
            langArray["Nov"],
            langArray["Dec"]
        ];

        Date.dayNames = [
            langArray["Sunday"],
            langArray["Monday"],
            langArray["Tuesday"],
            langArray["Wednesday"],
            langArray["Thursday"],
            langArray["Friday"],
            langArray["Saturday"]
        ];

        if(Ext.DatePicker){
            Ext.apply(Ext.DatePicker.prototype, {
              todayText         : langArray["Today"],
              monthNames        : Date.monthNames,
              dayNames          : Date.dayNames,
              cancelText    : langArray["Cancel"]
            });
        }

        var form = Ext.get('gridAdvancedSearch');
        if (form) {
            if (form.dom.style.display != 'none')
            return;
        }

        var objs = Ext.query('.date-picker');
            Ext.each(objs, function(x,index) {
                var obj = Ext.get(x);
                var content = /*new Date();*/obj.dom.innerHTML;
                obj.dom.innerHTML = "";
                var field = new Ext.form.DateField({
                    editable:    false,
                    format:        'Y-m-d',
                    renderTo:    x,
                    width:        198,
                    height:        22,
                    name:        'filter[' + obj.id + ']',
                    value:        content,
                    cls:        'no-input-border',
                    id:            'combo_' + obj.id,
                    listeners: {
                        focus: function() {
                            if (obj.id === objs[0].id + "_end") {
                                var first_datepicker = Ext.getCmp('combo_' + objs[0].id).getValue();
                                Ext.getCmp('combo_' + obj.id).setMinValue(first_datepicker);
                            }
                        }
                    }
                });
                FilterMemoryMgr.push(field);
            });
    },
    downtimeAdvSearchBehavior: function(me) {
        var isChecked = me.checked;

        Ext.getCmp('log_day_panel').setDisabled(!isChecked);
        Ext.getCmp('log_day_end_panel').setDisabled(!isChecked);
        Ext.get('planned').dom.disabled = isChecked;
        Ext.get('active').dom.disabled = isChecked;
    },
    adjustGridLayout: function() {

        var header = Ext.get('gridHeaderBox');
        if (!header)
            return;
        var tbar = Ext.get('gridToolbar');
        if (!tbar)
            return;

        tbar.setWidth( header.getWidth() );

        var body = Ext.getBody();
        if (!body)
            return;
        var tableBody = Ext.get('gridTableBody');
        if (!tableBody)
            return;
        var newSize = body.getHeight()-130;

        if (tableBody.getHeight()>=newSize) {
            tableBody.setHeight(newSize);
            return;
        }

        if (tableBody.dom.style.removeAttribute)
            tableBody.dom.style.removeAttribute("height");
        else
            tableBody.dom.style.removeProperty("height");

    },
    editServices: function() {
        var props = {};
        var selectedServices;

        selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
        if (selectedServices.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        props.action = "editServices";
        props.services = selectedServices;
        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    editHosts: function() {
        var hosts;
        var props = {};

        props.hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
        if (props.hosts.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    addHost: function() {
        var hosts;
        var props = {
            action: 'addHost'
        };

        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    cloneService: function() {
        var props = {};
        var selectedServices;

        selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
        if (selectedServices.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        props = {
            action: 'cloneService',
            services: selectedServices,
            width: 910,
            height: 580
        };

        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    cloneHost: function() {

        hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
        if (hosts.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        var hosts;
        var props = {
            action: 'cloneHost',
            hostName: hosts[0],
            width: 400,
            height: 190
        };

        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    delHost: function() {
        var sel = StatusgridEvents.getSelectedCheckboxes(true);

        if (sel.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        if(sel.find(item => item.hostname === 'opmon')){
            StatusgridEvents.cannotRemoveOpmon();
            return;
        }

        var ids = sel.map(item => item.id).filter(value => !isNaN(value));

        var props = {
            action: 'deleteHosts',
            hosts: ids,
            title: langArray['Remove']
        };

        props.callback = "StatusgridEvents.closeConfigurationWindow";
        Statusgrid.openConfigurationWindow(props);
    },
    closeConfigurationWindow: function(success) {
        if (success)
            parent.showSystemAlert(ALERT_OK,langArray['Informations'],langArray['Command submitted successfully']);

        var w = Ext.getCmp("global_config_window");
        if (w)
            w.destroy();

        Ext.get("gridRefresh").dom.onclick({});
    },
    genPDFFromGrid: function () {

        var action = Ext.get('gridName').dom.value;
        var params = Ext.get('gridParams').dom.value.split("&");
        var tmp    = Ext.get('gridFilter').dom.value;
        var title  = Ext.get('gridTitle').dom.value;;
        var filter = {};
        var URL;

        filter.collapsed_hosts = [];
        Ext.each(CollapsedElements, function(id) {
            filter.collapsed_hosts.push(
                id.replace('grid-row-id-',"")
            );
        });

        if (action == 'notifications') {
            URL = '/opmon/seagull/www/index.php/opexporter/action/genpdffromnotificationsgrid/';
        } else {
            URL = '/opmon/seagull/www/index.php/opexporter/action/genpdffromgrid/';
        }


        var icon = Ext.get('genpdf_icon');
        if (icon) {
            icon.dom.src = icon.dom.src.replace("icon-pdf", "loading");
            doingPDF = true;
        }


        if (tmp !== undefined) {
            filter.filter = Ext.JSON.decode(tmp, true);
            filter.params = {};
            var obj;
            Ext.each(params, function (el){
                el = el.split('=');
                if (el[0] !== "limit") {
                    obj = (obj === undefined) ? '"' + el[0] + '":"' + el[1] + '"' : obj + ',"' + el[0] + '":"' + el[1] + '"';
                } else {
                    obj = (obj === undefined) ? '"' + el[0] + '":"0"' : obj + ',"' + el[0] + '":"0"';
                }
            });

            filter.params    = Ext.JSON.decode("{" + obj + "}", true);
        } else {
            filter.filter = {};
        }

        filter.type     = action;
        if (title !== undefined) {
            filter.title    = encodeURI(title);
        }

        if (action == 'notifications') {
            filter.form_to  = 40;
        } else if (action == "services") {
            filter.form_to  = 50;
        } else if (action == "servicegroups") {
            filter.form_to  = 51;
        }

        filter = Ext.JSON.encode(filter);
        URL += '&jsonData=' + filter;

        Ext.Ajax.useDefaultXhrHeader = false;
        Ext.Ajax.request({
            url: URL,
            method: 'GET',
            timeout: 180000,
            success: function (result, request) {
                var obj = Ext.JSON.decode(result.responseText);
                location = obj.cacheurl;

                icon = Ext.get('genpdf_icon');
                if (icon) {
                    icon.dom.src = icon.dom.src.replace("loading", "icon-pdf");
                    doingPDF = false;
                }
            },
            failure: function (request, result) {
                icon = Ext.get('genpdf_icon');
                if (icon) {
                    icon.dom.src = icon.dom.src.replace("loading", "icon-pdf");
                    doingPDF = false;
                }
            }
        });
        Ext.Ajax.useDefaultXhrHeader = true;
    },
    genReportFromGrid: function(reportType, objectType) {

        var URL;
        var CPREPORT = 1;

        if (reportType != CPREPORT) {
            URL = '/opmon/seagull/www/index.php/opreports/action/index/';
        } else {
            URL = '/opmon/seagull/modules/opreports/ng/app.php';
        }

        // Set reportType
        URL += '?formTo=' + reportType;

        // Set manualMode
        var manualMode = new Object();
        manualMode.reportType = '0';
        manualMode.timeCutName = '24x7';
        manualMode.reportPeriod    = 'last24hours';
        manualMode.objectType = objectType;
        manualMode.timeCutId = Ext.get('gridReportPeriod').dom.value;

        manualMode.selectedItensDescription = [];
        manualMode.selectedItens = StatusgridEvents.getSelectedCheckboxes(reportType.toString() === CPREPORT.toString());

        manualMode.selectedItens.forEach(function(item){
            manualMode.selectedItensDescription.push(reportType.toString() === CPREPORT.toString() ? {value: item.value} : {value: item})
        });

        if (manualMode.selectedItens.length === 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        parent.manualMode = Ext.JSON.encode(manualMode);
        console.log(parent.manualMode)

        var frame = parent.Ext.get('mainFrame');
        frame.dom.src = URL;

    },
    getSelectedCheckboxesFromLocalStorage: function() {
        var selectedItems = localStorage.getItem("items-items");
        if (typeof selectedItems !== 'string') {
            return [];
        }

        if (selectedItems.indexOf(',' > -1)) {
            return selectedItems.split(',');
        }

        return [selectedItems];
    },
    getSelectedCheckboxes: function(withNames) {
        var selectedItems = [];
        var validIds = /^\d+/;
        Ext.each(Ext.query("input[class^=row-checkbox]"), function(box) {
            if (!box.checked || !validIds.test(box.getAttribute('data-id'))) {
                return;
            }
            selectedItems.push(withNames ? StatusgridEvents.getRowNames(box) : box.getAttribute('data-id'));
        });
        return selectedItems;
    },
    getRowNames: function(row) {
        return (row.getAttribute("servicedescription"))
            ? ({ id: row.getAttribute("data-id"), hostname: row.getAttribute("hostname"), service_description: row.getAttribute("servicedescription") })
            : ({ id: row.getAttribute("data-id"), hostname: row.getAttribute("hostname") })
    },
    runExternalCommand: function(objectType) {
        var objects = [];
        var win;

        objects = StatusgridEvents.getSelectedCheckboxes();
        if (objects.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }
        win = Ext.create('Ext.window.Window',{
            id:             'extCmdWin',
            layout:         'fit',
            width:          260,
            autoHeight:     true,
            y:              100,
            buttonAlign:    'center',
            plain:          false,
            modal:          true,
            closable:       false,
            closeAction:    'destroy',
            draggable:      false,
            shadow:         false,
            bodyCls:        'ext-window',
            bodyBorder:     false,
            hideBorders:    false,
            resizable:      false,
            loader: {
                url: '/opmon/seagull/www/index.php/statusgrid/action/external_command_list/?',
                method: 'POST',
                params: {
                    elements: Ext.JSON.encode(objects),
                    objectType: objectType
                },
                text: langArray['Loading'] + '...',
                nocache: true,
                autoLoad: true,
                success: function(){
                    win.center();
                }
            },
            listeners: {
                hide: function() {
                    Ext.get('cmdWin').dom.innerHTML = "";
                }
            }
        }).show();
    },
    forceCheckNow: function(objectType) {
        var objects = [];

        objects = StatusgridEvents.getSelectedCheckboxes();

        if (objects.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }
        var elements = Ext.JSON.encode(objects);
        if (objectType == 0) {
            submitCmdNow(elements, 'hostRescheduleNextCheck');
        }
        else {
            submitCmdNow(elements, 'serviceRescheduleNextCheck');
        }
    },
    genRealtimeGraph: function() {

        var objects;
        objects = StatusgridEvents.getSelectedCheckboxes();

        if (objects.length == 0) {
            StatusgridEvents.noElementSelected();
            return;
        }

        Ext.each(objects,function(obj,index) {
            if (obj.indexOf("!") < 0)
                return;

            var objIds = [];
            objIds = obj.split("!");
            var url = '/opmon/seagull/www/index.php/statusgrid/action/realtimegraph';
            url += '/host_id/' + objIds[0];
            url += '/service_id/' + objIds[1];
            var win = window.open(url,'','height=340,width=1024,scrollbars=no,menubar=no,resizable=yes,toolbar=no,location=no,status=no');
        });

    },
    addFavoriteLink: function() {
        if (parent)
            parent.addFavoriteLink();
    },
    addShortcutLink: function() {
        if (parent)
            parent.addShortcutLink();
	},
	toggleCheckbox: function(checkbox) {
		var xs = document.querySelectorAll('input[name="filter[display_status][]"');
		var xs = Array.prototype.slice.call(xs);
		var value = checkbox.checked;
		xs.forEach(function(x) {
            x.checked = value;
		});

	},
    statusgridReady: function() {
        var elementsToCollapse = document.querySelectorAll("img[data-collapse='1']");
        CollapsedElements
            .map(function(id) { return document.querySelector("img[data-id='"+id+"']"); })
            .concat(Array.prototype.slice.call(elementsToCollapse))
            .filter(function(el) { return !!el; })
            .forEach(function(img) {
                var imgId = img.getAttribute("data-id");
                if (img.getAttribute("src").match(/minus.png/) && ExpandedElements.every(function(id) { return id !== imgId; })) {
                    StatusgridEvents.displayRows(img, false, false);
                }
            });
        createScrollEvent();
        updateHeightFooterSpace();
        putToolTipOnSummaryStatus();

        var breadcrumbInput = Ext.get('gridBreadcrumb')
        var breadcrumb = Ext.get('monitor-status-filter-breadcrumb');

        if (breadcrumb && breadcrumbInput) {
            breadcrumb.dom.innerHTML = breadcrumbInput.dom.value;
        }
    },
    selectRow: function selectRow(e) {
        var el = Ext.get(StatusgridHelpers.getParent("grid-row") (e.target))
        if (el) {
          var f = e.target.checked ? "addCls" : "removeCls";
          el[f]("statusgrid-row-selected");
        }
    },
    remakeSearch : function() {
        var search = parent.document.getElementsByName("filter[search]")[0].value
        var form = document.getElementById("advancedSearchForm");

        if (search == "(" + langArray["Filter activated"] + ")") {
            form.submit();
            return false;
        }
    },
    verifyIfStateAlreadyWasEnabled : function (value, key, array) {
        return array.some(function(current) {
            return current.attributes.name.value === value;
        })
    },
    filterGridByStatus: function(state, object) {
        var baseURL = '/opmon/seagull/www/index.php/statusgrid/action/' + object;
        var state = state.getAttribute("name");
        var params = Ext.get('gridParams').dom.value;
        var breadcrumb = Ext.get('gridBreadcrumb');

        var summarysStates = Ext.query("*[id^=summary-status]");
        var filterDisplayStatus = [];

        var isStateEnabled = this.verifyIfStateAlreadyWasEnabled(state, 'attributes.name.value',summarysStates );

        summarysStates.forEach(function(summaryState){
           if (state != summaryState.attributes.name.value) {
                filterDisplayStatus.push(summaryState.attributes.name.value);
           }

        });

        if (! isStateEnabled) {
            filterDisplayStatus.push(state);
        }

        var filter = Ext.get('gridFilter').dom.value;
        filter = (filter) ? JSON.parse(filter): {}
        filter.display_status = filterDisplayStatus;

        filter = JSON.stringify(filter);

		var url = baseURL + "/?" + params + "&filter=" + filter;

        if(breadcrumb) {
			url += "&breadcrumb=" + breadcrumb.dom.value;
		}

        Ext.get('gridFilter').dom.value = filter
        Ext.Ajax.request({
            url: url,
            method: 'GET',
            callback: function(opt, success, resp) {
                Statusgrid.processRequest(opt, success, resp)
            }
        });
    }
}


var StatusgridHelpers = (function() {

    // getParent :: String -> NodeHtml -> NodeHtml || null
    var getParent = function(selector) {
        return function(el) {
            return (!el || el.className.match(selector))
                ? el
                : getParent(selector)(el.parentElement)
        }
    }

    // takeNextSiblingWhile :: (NodeHtml -> Bool, [ NodeHtml ]) -> NodeHtml -> [ NodeHtml ]
    var takeNextSiblingWhile = function(f, acc) {
        var xs = (Array.isArray(acc)) ? acc : [];
        return function(el) {
            return (!el || !f(el))
                ? xs
                : takeNextSiblingWhile(f, xs.concat(el)) (el.nextElementSibling)
        }
    }

    return {
        getParent: getParent,
        takeNextSiblingWhile: takeNextSiblingWhile
    };

}) ();


var StatusgridComboSelector = function(init) {

    function check(status) {
        var f = status ? StatusgridEvents.cookieAddEl : StatusgridEvents.cookieDelEl;
        var valid_ids = /^\d+.*$/;

        return function(input) {
            if (status !== input.checked) {
               input.click();
            }
            f(input.getAttribute('data-id')); // perform "save or remove" in cookie
        }
    }

    function checkIndeterminate(xstatus, ystatus) {
        return function(input, state, silent) {
            if (xstatus !== input.checked) {
                if (silent) {
                    input.checked = xstatus;
                } else {
                    input.click();
                }
            }
            if (ystatus !== input.indeterminate) {
                input.indeterminate = ystatus;
            }
            if (!xstatus && !input.checked && !ystatus && !input.indeterminate) {
                StatusgridEvents.selectRow({ target: input })
            }
            input.setAttribute("data-status", state || init);
        }
    }

    function isServiceRow(row) {
        return row.className.match(/grid-row-id-*/);
    }

    function markIfIsService(input) {
        var row = StatusgridHelpers.getParent("grid-row")(input);
        return isServiceRow(row) ? markAsTrue(input) : markAsFalse(input);
    }

    function getNextState(m, states) {
        return states.reduce(
            function nextStateReduce(result, state, i) {
                return (m.getAttribute("data-status") || "").match(state) ? states[(i + 1) % states.length] : result;
            }
            , init
        );
    }

    function each(f) {
        return function(inputs) {
            inputs.forEach(f);
        }
    }

    var markAsTrue = check(true);

    var markAsFalse = check(false);

    var checkMainActions = {
        indeterminate: checkIndeterminate(false, true),
        checked: checkIndeterminate(true, false),
        unchecked: checkIndeterminate(false, false)
    };

    var checkRowActions = {
        indeterminate: each(markIfIsService),
        checked: each(markAsTrue),
        unchecked: each(markAsFalse)
    };

    function performChanges(state, main, inputs) {
        if (checkMainActions[state] && checkRowActions[state]) {
            checkMainActions[state](main, state, true);
            checkRowActions[state](inputs);
            dontPerformForEachHost = false;
        }
    }

    return {
        getNextState: getNextState,
        performChanges: performChanges
    };
}



